; copyright (c) Sergey Volkov
; email: volser@inbox.ru
include "HJConst.JSH"

Globals
handle abilonfocus

Void Function AutoStartEvent ()
if (abilonfocus) then
SetFocus (abilonfocus)
EndIf
EndFunction

function FocusChangedEvent (handle FocusWindow, handle PrevWindow)
var
string winclass
let winclass = GetWindowClass (GetCurrentWindow ())
If ((winclass == "ColumnsTreeView" || winclass == "RSSItemsCtrl" || winclass == "Internet Explorer_Server") && IsPCCursor ()) then
let abilonfocus=FocusWindow
EndIf

If (winclass == "RSSItemsCtrl" && IsPCCursor ()) then
if (GetCharacterAttributes () & ATTRIB_Bold) then
Say ("", OT_STATUS, false)
Say (" ", OT_STATUS, false)
EndIf
SayLine ()
	return
EndIf

FocusChangedEvent (FocusWindow, PrevWindow)
EndFunction

Script Tab ()
var
string winclass,
handle hwnd
let winclass = GetWindowClass (GetCurrentWindow ())

If (winclass == "RSSItemsCtrl" && IsPCCursor ()) then
let hwnd=FindWindow (GetAppMainWindow (GetCurrentWindow ()), "Internet Explorer_Server", "")
if (hwnd) then
SayCurrentScriptKeyLabel ()
SpeechOff ()
SetFocus (hwnd)
Pause ()
Refresh ()
JAWSTopOfFile ()
NextLine ()
NextLine ()
SpeechOn ()
SayLine ()
return
EndIf
EndIf

PerformScript Tab()
EndScript

Script ShiftTab ()
var
string winclass,
handle hwnd
let winclass = GetWindowClass (GetCurrentWindow ())

If (winclass == "Internet Explorer_Server" && IsPCCursor ()) then
let hwnd=FindWindow (GetAppMainWindow (GetCurrentWindow ()), "RSSItemsCtrl", "")
if (hwnd) then
SayCurrentScriptKeyLabel ()
SetFocus (hwnd)
return
EndIf
EndIf

If (winclass == "ColumnsTreeView" && IsPCCursor ()) then
let hwnd=FindWindow (GetAppMainWindow (GetCurrentWindow ()), "Internet Explorer_Server", "")
if (hwnd) then
SayCurrentScriptKeyLabel ()
SpeechOff ()
SetFocus (hwnd)
Pause ()
Refresh ()
JAWSTopOfFile ()
NextLine ()
NextLine ()
SpeechOn ()
SayLine ()
return
EndIf
EndIf

If (winclass == "RSSItemsCtrl" && IsPCCursor ()) then
let hwnd=FindWindow (GetAppMainWindow (GetCurrentWindow ()), "ColumnsTreeView", "")
if (hwnd) then
SayCurrentScriptKeyLabel ()
SetFocus (hwnd)
return
EndIf
EndIf

PerformScript ShiftTab()
EndScript

Void Function SayHighLightedText (handle hwnd, string buffer)
var
string winclass
let winclass=GetWindowClass (hwnd)
If ((winclass == "ColumnsTreeView" || winclass == "RSSItemsCtrl" || winclass == "Internet Explorer_Server") && IsPCCursor () && hwnd!=GetFocus ()) then
return
EndIf
if (winclass=="RSSItemsCtrl") then
if (GetCharacterAttributes () & ATTRIB_Bold) then
Say ("", OT_STATUS, false)
Say (" ", OT_STATUS, false)
EndIf
CheckGraphicsOnEnd()
EndIf
SayHighLightedText (hwnd, buffer)
EndFunction

Script SayLine()
var
string winclass
let winclass = GetWindowClass (GetCurrentWindow ())
If (winclass == "RSSItemsCtrl" && IsPCCursor ()) then
if (GetCharacterAttributes () & ATTRIB_Bold) then
Say ("", OT_STATUS, false)
Say (" ", OT_STATUS, false)
EndIf
CheckGraphicsOnEnd()
SayLine ()
	return
EndIf
PerformScript SayLine()
EndScript

Void Function CheckGraphicsOnEnd ()
var
string sGraphicCharacter,
int iRestLevel,
int iCount
SaveCursor ()
RouteInvisibleToPc ()
InvisibleCursor ()
let iRestLevel = GetRestriction()
SetRestriction (RestrictWindow)
JAWSEnd ()
					let iCount = 0
while ((GetCharacterAttributes () & ATTRIB_GRAPHIC ) && iCount <= 4)
let sGraphicCharacter = GetCharacter ()
if (sGraphicCharacter == "Attrib_Park") then
Say ("", OT_STATUS, false)
Say (" ", OT_STATUS, false)
endif
PriorWord ()
let iCount = iCount + 1
endwhile
SetRestriction(iRestLevel)
RestoreCursor ()
EndFunction

Script LeftMouseButton ()
var
string winclass
let winclass = GetWindowClass (GetCurrentWindow ())
If ((winclass == "ColumnsTreeView" || winclass == "RSSItemsCtrl") && IsPCCursor ()) then
RouteJAWSToPc ()
endif
PerformScript LeftMouseButton ()
EndScript

Script RightMouseButton ()
var
string winclass
let winclass = GetWindowClass (GetCurrentWindow ())
If ((winclass == "ColumnsTreeView" || winclass == "RSSItemsCtrl") && IsPCCursor ()) then
RouteJAWSToPc ()
endif
PerformScript RightMouseButton ()
EndScript

Script StatusBar ()
var
handle status
let status=FindDescendantWindow (GetAppMainWindow (GetCurrentWindow ()), 59393)
if (status) then
SayWindow (status, READ_EVERYTHING)
EndIf
EndScript
